#pragma once

#include <stdnoreturn.h>
#include <stddef.h>

#define LKT_OPT_NULL            { .name = NULL, .call = NULL }
#define LKT_OPT_DEFAULT(func)   { .name = NULL, .call = func }

struct lkt_cmd_args {
    int argc;               /* The number of arguments passed.  */
    const char **argv;      /* An array of argument passed.     */
};

typedef void (*lkt_cmd_callback)(struct lkt_cmd_args *);

struct lkt_cmd_opt {
    const char *name;
    lkt_cmd_callback call;
};

/* Parse the command line with the list of options. No parameter may be NULL.
   Does not return. */
noreturn void lkt_cmd_parse(struct lkt_cmd_opt *opts, int argc, const char **argv);

/* Must be setted for the lkt_cmd_parse function to display the correct help
   in case of errors. */
extern const char *executable_name;
