#define _POSIX_C_SOURCE 200809L

#include <common/common.h>
#include <lektor/config.h>
#include <lektor/net.h>
#include <lektor/database.h>
#include <mthread/mthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>
#include <pwd.h>
#include <pthread.h>

/* Prints the help of the program */
static void
print_help(void)
{
    const char *HELP = "NAME                                            \n"
                       "    lektord -- lektor player daemon             \n"
                       "                                                \n"
                       "SYNOPSIS                                        \n"
                       "    lektord [OPTIONS]...                        \n"
                       "                                                \n"
                       "DESCRIPTION                                     \n"
                       "                                                \n"
                       "    -h / --help                                 \n"
                       "        display the help and exit               \n"
                       "                                                \n"
                       "    -v / --version                              \n"
                       "        display the version of lektor and exit  \n"
                       "\n";

    write(1, HELP, strlen(HELP));
}

int
main(int argc, char *argv[])
{
    struct passwd *pw = getpwuid(getuid());
    pthread_t th;

    if (argc <= 1)
        goto normal_launch;
    else if (strcasecmp(argv[1], "--help") == 0 ||
             strcasecmp(argv[1], "-h") == 0) {
        print_help();
        return EXIT_SUCCESS;
    } else if (strcasecmp(argv[1], "--version") == 0 ||
               strcasecmp(argv[1], "-v") == 0) {
        printf("Lektor version 0.1\n");
        return EXIT_SUCCESS;
    }

    return EXIT_FAILURE;

normal_launch:
    LOG_INFO("Lektor launched by user %s (shell: %s, home: %s)", pw->pw_name, pw->pw_shell, pw->pw_dir);
    mthread_init();
    pthread_create(&th, NULL, mthread_main, NULL);
    return lkt_listen();
}
